% Adaptive Mixed Grey Wolf Optimizer
%%% inspired by:

%%% the a parameter is polynomial
%___________________________________________________________________%
%  Grey Wold Optimizer (GWO) source codes version 1.0               %
%                                                                   %
%  Developed in MATLAB R2011b(7.13)                                 %
% %                                                                   %
%  Author and programmer: Seyedali Mirjalili                        %
%                                                                   %
%         e-Mail: ali.mirjalili@gmail.com                           %
%                 seyedali.mirjalili@griffithuni.edu.au             %
%                                                                   %
%       Homepage: http://www.alimirjalili.com                       %
%                                                                   %
%   Main paper: S. Mirjalili, S. M. Mirjalili, A. Lewis             %
%               Grey Wolf Optimizer, Advances in Engineering        %
%               Software , in press,                                %
%               DOI: 10.1016/j.advengsoft.2013.12.007               %
%                                                                   %
%___________________________________________________________________%


%%%% Mthodologie Discrete GWO:

%1) slection du leader soit alpha soit beta soit delta
%2) dplacement vers le leader de d units



function [Alpha_score,Alpha_pos,Convergence_curve,Final_Iter_Index]=GWO_aMixed...
    (nb_search_agent,Nb_Leaders_GWO,...
    it_max,power_for_a,...
    Parameter_Set_Search_Sets,Integer_Constrained,Option_Continuous_Refinment,...
    Parameter_Set_Alpha_Initial_Position,min_FRR,dim,...
    Name_Objective_Function,Optimizer)

%%% power_for_a: \eta 

it_max_first_half=ceil(it_max/2);
it_max_second_half=it_max-it_max_first_half;

power_for_a_first_half=power_for_a;
power_for_a_second_half=1/power_for_a;

if Option_Continuous_Refinment==0
it_max_2=it_max_second_half;
elseif Option_Continuous_Refinment==1 
it_max_2=ceil(it_max_second_half/4);
end


[Alpha_score,Alpha_pos,Convergence_curve_First_Half,Final_Iter_Index]=GWO_aMixed_Fixed_Power_for_a...
    (nb_search_agent,Nb_Leaders_GWO,...
    it_max_first_half,power_for_a_first_half,...
    Parameter_Set_Search_Sets,Integer_Constrained,...
    Parameter_Set_Alpha_Initial_Position,min_FRR,dim,...
    Name_Objective_Function,Optimizer);
 

Parameter_Set_Alpha_Initial_Position=Alpha_pos(:);

[Alpha_score,Alpha_pos,Convergence_curve2,Final_Iter_Index]=GWO_aMixed_Fixed_Power_for_a...
    (nb_search_agent,Nb_Leaders_GWO,...
    it_max_2,power_for_a_second_half,...
    Parameter_Set_Search_Sets,Integer_Constrained,...
    Parameter_Set_Alpha_Initial_Position,min_FRR,dim,...
    Name_Objective_Function,Optimizer);


if Option_Continuous_Refinment==0
Convergence_curve_Second_Half=Convergence_curve2;
elseif Option_Continuous_Refinment==1
%%% Refinment with a fully continuous version
Integer_Constrained=[];
Parameter_Set_Alpha_Initial_Position=Alpha_pos(:);
it_max_3=it_max_second_half-it_max_2;

[Alpha_score,Alpha_pos,Convergence_curve3,Final_Iter_Index]=GWO_aMixed_Fixed_Power_for_a...
    (nb_search_agent,Nb_Leaders_GWO,...
    it_max_3,power_for_a_second_half,...
    Parameter_Set_Search_Sets,Integer_Constrained,...
    Parameter_Set_Alpha_Initial_Position,min_FRR,dim,...
    Name_Objective_Function,Optimizer);

Convergence_curve2all=zeros(1,it_max_second_half);
Convergence_curve2all(1:it_max_2)=Convergence_curve2;
Convergence_curve2all(it_max_2+1:it_max_second_half)=Convergence_curve3;

Convergence_curve_Second_Half=Convergence_curve2all;
end

Convergence_curve=zeros(1,it_max);
Convergence_curve(1:it_max_first_half)=Convergence_curve_First_Half;
Convergence_curve(it_max_first_half+1:it_max)=Convergence_curve_Second_Half;


end
