%___________________________________________________________________%
%  Grey Wold Optimizer (GWO) source codes version 1.0               %
%                                                                   %
%  Developed in MATLAB R2011b(7.13)                                 %
%                                                                   %
%  Author and programmer: Seyedali Mirjalili                        %
%                                                                   %
%         e-Mail: ali.mirjalili@gmail.com                           %
%                 seyedali.mirjalili@griffithuni.edu.au             %
%                                                                   %
%       Homepage: http://www.alimirjalili.com                       %
%                                                                   %
%   Main paper: S. Mirjalili, S. M. Mirjalili, A. Lewis             %
%               Grey Wolf Optimizer, Advances in Engineering        %
%               Software , in press,                                %
%               DOI: 10.1016/j.advengsoft.2013.12.007               %
%                                                                   %
%___________________________________________________________________%

% This function initialize the first population of search agents
function [Positions_Indices,Positions_Values]=initialization_mixed...
    (SearchAgents_no,dim,Parameter_Set_Search_Sets,ub,lb,Parameter_Init_Position_Alpha,Parameter_Set_Alpha_Initial_Position_Values,Discrete_Indices,Continuous_Indices)

%%% Distinguish between position index and position value

Positions_Indices=zeros(SearchAgents_no,dim);
Positions_Values=zeros(SearchAgents_no,dim);



for i=1:1
    
    
    for j=Discrete_Indices
        Positions_Indices(i,j)=Parameter_Init_Position_Alpha(j);        
        Positions_Values(i,j)=Parameter_Set_Alpha_Initial_Position_Values(j);
        
    end
    
    for c=Continuous_Indices        
        Positions_Values(i,c) = Parameter_Set_Alpha_Initial_Position_Values(c);
    end
    
    
    
end

for i=2:SearchAgents_no
    
    
    for j=Discrete_Indices
        %%% Random permutation of the indices
        p = randperm(length(Parameter_Set_Search_Sets{j}));
        
        %%% Select at random an index for each set
        Positions_Indices(i,j)=p(1);        
        Positions_Values(i,j)=Parameter_Set_Search_Sets{j}(Positions_Indices(i,j));
        
    end
    
    for c=Continuous_Indices
        
        Positions_Values(i,c) = lb(c) + (ub(c)-lb(c))*rand;
        
    end
    
    
    
end



end